diff --git a/string/Makefile b/string/Makefile
index 470ff77ded..73e5ac2ebe 100644
--- a/string/Makefile
+++ b/string/Makefile
@@ -65,7 +65,7 @@ tests		:= tester inl-tester noinl-tester testcopy test-ffs	\
 # This test allocates a lot of memory and can run for a long time.
 xtests = tst-strcoll-overflow
 
-tests-container += tst-strsignal
+tests-container += tst-strsignal tst-strerror
 
 # This test needs libdl.
 ifeq (yes,$(build-shared))
@@ -118,5 +118,6 @@ $(objpfx)tst-strxfrm2.out: $(gen-locales)
 $(objpfx)bug-strcoll2.out: $(gen-locales)
 $(objpfx)tst-strcoll-overflow.out: $(gen-locales)
 $(objpfx)tst-strsignal.out: $(gen-locales)
+$(objpfx)tst-strerror.out: $(gen-locales)
 
 endif
diff --git a/string/tst-strerror.c b/string/tst-strerror.c
new file mode 100644
index 0000000000..3af51236d7
--- /dev/null
+++ b/string/tst-strerror.c
@@ -0,0 +1,76 @@
+/* Test for strerror, strerror_r, and strerror_l.
+
+   Copyright (C) 2020 Free Software Foundation, Inc.
+   This file is part of the GNU C Library.
+
+   The GNU C Library is free software; you can redistribute it and/or
+   modify it under the terms of the GNU Lesser General Public
+   License as published by the Free Software Foundation; either
+   version 2.1 of the License, or (at your option) any later version.
+
+   The GNU C Library is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   Lesser General Public License for more details.
+
+   You should have received a copy of the GNU Lesser General Public
+   License along with the GNU C Library; if not, see
+   <https://www.gnu.org/licenses/>.  */
+
+#include <string.h>
+#include <stdio.h>
+#include <errno.h>
+#include <locale.h>
+#include <array_length.h>
+
+#include <support/support.h>
+#include <support/check.h>
+
+static int
+do_test (void)
+{
+  xsetlocale (LC_ALL, "C");
+
+  TEST_COMPARE_STRING (strerror (EINVAL), "Invalid argument");
+  TEST_COMPARE_STRING (strerror (-1),     "Unknown error -1");
+
+  {
+    char buffer[32];
+    TEST_COMPARE_STRING (strerror_r (EINVAL, buffer, 8),
+			 "Invalid argument");
+    TEST_COMPARE_STRING (strerror_r (-1, buffer, 8),
+			 "Unknown");
+    TEST_COMPARE_STRING (strerror_r (-1, buffer, 16),
+			 "Unknown error -");
+    TEST_COMPARE_STRING (strerror_r (-1, buffer, 32),
+			 "Unknown error -1");
+  }
+
+  locale_t l = xnewlocale (LC_ALL_MASK, "pt_BR.UTF-8", NULL);
+
+  TEST_COMPARE_STRING (strerror_l (EINVAL, l), "Argumento inv\303\241lido");
+  TEST_COMPARE_STRING (strerror_l (-1, l),     "Erro desconhecido -1");
+
+  xuselocale (l);
+
+  TEST_COMPARE_STRING (strerror (EINVAL), "Argumento inv\303\241lido");
+  TEST_COMPARE_STRING (strerror (-1),     "Erro desconhecido -1");
+
+  {
+    char buffer[32];
+    TEST_COMPARE_STRING (strerror_r (EINVAL, buffer, 8),
+			 "Argumento inv\303\241lido");
+    TEST_COMPARE_STRING (strerror_r (-1, buffer, 8),
+			 "Erro de");
+    TEST_COMPARE_STRING (strerror_r (-1, buffer, 16),
+			 "Erro desconheci");
+    TEST_COMPARE_STRING (strerror_r (-1, buffer, 32),
+			 "Erro desconhecido -1");
+  }
+
+  freelocale (l);
+
+  return 0;
+}
+
+#include <support/test-driver.c>
diff --git a/support/Makefile b/support/Makefile
index 51484310cd..764b471033 100644
--- a/support/Makefile
+++ b/support/Makefile
@@ -108,6 +108,7 @@ libsupport-routines = \
   xmmap \
   xmprotect \
   xmunmap \
+  xnewlocale \
   xopen \
   xpipe \
   xpoll \
@@ -173,6 +174,7 @@ libsupport-routines = \
   xsymlink \
   xsysconf \
   xunlink \
+  xuselocale \
   xwaitpid \
   xwrite \
 
diff --git a/support/support.h b/support/support.h
index 8e1a6a17f7..905b5a76d8 100644
--- a/support/support.h
+++ b/support/support.h
@@ -29,6 +29,8 @@
 #include <sys/stat.h>
 /* For ssize_t and off64_t.  */
 #include <sys/types.h>
+/* For locale_t.  */
+#include <locale.h>
 
 __BEGIN_DECLS
 
@@ -92,6 +94,8 @@ char *xasprintf (const char *format, ...)
 char *xstrdup (const char *);
 char *xstrndup (const char *, size_t);
 char *xsetlocale (int category, const char *locale);
+locale_t xnewlocale (int category_mask, const char *locale, locale_t base);
+char *xuselocale (locale_t newloc);
 
 /* These point to the TOP of the source/build tree, not your (or
    support's) subdirectory.  */
diff --git a/support/xnewlocale.c b/support/xnewlocale.c
new file mode 100644
index 0000000000..f532873c7f
--- /dev/null
+++ b/support/xnewlocale.c
@@ -0,0 +1,31 @@
+/* newlocale with error checking.
+   Copyright (C) 2020 Free Software Foundation, Inc.
+   This file is part of the GNU C Library.
+
+   The GNU C Library is free software; you can redistribute it and/or
+   modify it under the terms of the GNU Lesser General Public
+   License as published by the Free Software Foundation; either
+   version 2.1 of the License, or (at your option) any later version.
+
+   The GNU C Library is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   Lesser General Public License for more details.
+
+   You should have received a copy of the GNU Lesser General Public
+   License along with the GNU C Library; if not, see
+   <https://www.gnu.org/licenses/>.  */
+
+#include <support/check.h>
+
+#include <locale.h>
+
+locale_t
+xnewlocale (int category_mask, const char *locale, locale_t base)
+{
+  locale_t r = newlocale (category_mask, locale, base);
+  if (r == (locale_t) 0)
+    FAIL_EXIT1 ("error: newlocale (%d, \"%s\", %p)\n", category_mask,
+		locale, base);
+  return r;
+}
diff --git a/support/xuselocale.c b/support/xuselocale.c
new file mode 100644
index 0000000000..3d6125b57d
--- /dev/null
+++ b/support/xuselocale.c
@@ -0,0 +1,30 @@
+/* uselocale with error checking.
+   Copyright (C) 2020 Free Software Foundation, Inc.
+   This file is part of the GNU C Library.
+
+   The GNU C Library is free software; you can redistribute it and/or
+   modify it under the terms of the GNU Lesser General Public
+   License as published by the Free Software Foundation; either
+   version 2.1 of the License, or (at your option) any later version.
+
+   The GNU C Library is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   Lesser General Public License for more details.
+
+   You should have received a copy of the GNU Lesser General Public
+   License along with the GNU C Library; if not, see
+   <https://www.gnu.org/licenses/>.  */
+
+#include <support/check.h>
+
+#include <locale.h>
+
+locale_t
+xuselocale (locale_t newloc)
+{
+  locale_t r = uselocale (newloc);
+  if (r == (locale_t) 0)
+    FAIL_EXIT1 ("error: uselocale (%p)\n", newloc);
+  return r;
+}